/*	baseexec.c Copyright 1991 H.Ogasawara	*/

#include	"mmf.h"
/*#include	"resize.inc"*/
/*#include	"disk.inc"*/

ClientPack	*setclient;

static int	drawflag= TRUE;
static int	zoomflag= FALSE;

static void
ScrollOpen( cp )
ClientPack	*cp;
{
	if( cp->swp )
		WindowClose( cp->swp );
	cp->swp= WindowScrollOpen( SCROLLXPOS, SCROLLYPOS,
			HS_WindowGetViewSizeX(cp->bwp)-SCROLLXPOS,
			HS_WindowGetViewSizeY(cp->bwp)-SCROLLYPOS,
			cp->bwp, (MAXFILESTR/2)*cp->font_y+FNAMEX,
			cp->maxline*cp->font_y,
			DirectionX|DirectionY,
			SCROLLSTEPX, cp->font_y/*SCROLLSTEPY*/, ScrollExec );
	WindowSetEventAttr( cp->swp,	EventOpenON
					|EventCloseON
					|EventMouseSwitchON
					|EventRedrawON
				);
	HS_WindowGetClientPointer(cp->swp)= cp;
}

/* pXXCb`̕\ */
static DrawBuf *
pathdraw( dp, cp )
DrawBuf		*dp;
ClientPack	*cp;
{
	int		i;
	extern Sheet	DiskPat;
#define	PY	9
	DrawSetLine( dp++, 0, 0, HS_WindowGetViewSizeX(cp->bwp)-1,
					SCROLLYPOS-1, BACKCOLOR, OptionFill );
	DrawSetSymbol( dp++, 2, 1+PY, (char*)cp->splitpath, FCOLOR, 12 );
/*	DrawSetPut( dp++, 2, 1, IconP[2].pat );*/
	setdirmark( (*cp->splitpath-1) & 0x1f );
	DrawSetPut( dp++, 2, 1, &DiskPat );
	if( cp->splitnum )
		DrawSetLine( dp++, 1, 1+PY, 16, 13+PY, ShadowUp,OptionShadow );
	for( i= 0 ; i< cp->splitnum-1 ; i++ )
		DrawSetLine( dp++, 18+i*6*5, 1+PY, 18+i*6*5+24+3, 13+PY,
						   ShadowUp, OptionShadow );
	return	dp;
}

/* EBhẼTCYRg[ */
void
windowresize( cp, x, y, h, v )
ClientPack	*cp;
int		x,
		y,
		h,
		v;
{
	if( x < 0 )
		x= HS_WindowGetPositionX(cp->bwp);
	if( y < 0 )
		y= HS_WindowGetPositionY(cp->bwp);
/*	if( v > cp->maxline*cp->font_y+14+SCROLLYPOS ){
		v= cp->maxline*cp->font_y+14+SCROLLYPOS;
		if( v < 48 )
			v= 48;
	}*/
	if( v > 512-14-SCROLLYPOS )
		v= 512-14-SCROLLYPOS;
	if( h > (MAXFILESTR/2)*cp->font_y+FNAMEX+14 )
		h= (MAXFILESTR/2)*cp->font_y+FNAMEX+14;
	drawflag= FALSE;
	WindowResize( cp->bwp, x, y, h, v );
	drawflag= TRUE;
	WindowResize( cp->swp, SCROLLXPOS, SCROLLYPOS, h-SCROLLXPOS,
								v-SCROLLYPOS );
	zoomflag= FALSE;
	WindowRedraw( cp->swp );
}

/* fBNg̈ړ */
chgposition( cp )
ClientPack	*cp;
{
	DrawBuf	dbuf[20];
	int	i;
	extern unsigned char	*gmask;
	for( i= 0 ; i< BANKMAX ; i++ )
		if( !strcmpi( cp->path, cp->bank[i]->buf ) )
			break;
	strcpy( cp->mask, i<BANKMAX ? cp->bank[i]->mask : (void*)gmask );
	if( i<BANKMAX )
		cp->sortmode= cp->bank[i]->sortmode;
	makedirlist( cp );
	ScrollOpen( cp );
	if( i < BANKMAX ){
		extern short	windowbank;
		WindowSetHome( cp->swp, cp->bank[i]->x, cp->bank[i]->y );
		if( windowbank &&
			(HS_WindowGetViewSizeX(cp->bwp) != cp->bank[i]->h ||
			HS_WindowGetViewSizeY(cp->bwp) != cp->bank[i]->v) ){
			windowresize( cp, -1, -1, cp->bank[i]->h, cp->bank[i]->v );
			return;
		}
	}
	WindowDraw( cp->bwp, dbuf, pathdraw( dbuf, cp )-dbuf );
	WindowRedraw( cp->swp );
}

/* fBNg̍ēǂݍ */
resetposition( cp, flag )
ClientPack	*cp;
int		flag;
{
	DrawBuf	dbuf[20];
	int	x,y;
	if( flag ){
		x= HS_WindowGetHomeX(cp->swp);
		y= HS_WindowGetHomeY(cp->swp);
	}
	makedirlist( cp );
	ScrollOpen( cp );
	WindowDraw( cp->bwp, dbuf, pathdraw( dbuf, cp )-dbuf );
	if( flag )
		WindowSetHome( cp->swp, x, y );
	WindowRedraw( cp->swp );
}

BaseExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp,	EventOpenON
					|EventCloseON
					|EventMouseSwitchON
					|EventRedrawON
					|EventResizeON
					|EventIconifyON
					|EventZoomON
					|EventKeyON
					|EventUserON
				);
		setclient->bwp= wp;
		setclient->swp= 0;
		setclient->info= info;
		bankinit( setclient );
		ScrollOpen( setclient );
		HS_WindowGetClientPointer(wp)= setclient;
		WindowRedraw( wp );
		return	TRUE;
	case EventRedraw:
		{
			ClientPack	*cp= HS_WindowGetClientPointer(wp);
			DrawBuf		dbuf[22],
					*dp= dbuf;
			DrawSetPut( dp++, HS_WindowGetViewSizeX(wp)-10,
				HS_WindowGetViewSizeY(wp)-10, IconP[3].pat /*&ResizePattern*/ );
			dp= pathdraw( dp, cp );
			WindowDraw( wp, dbuf, dp-dbuf );
			if( drawflag )
				WindowRedraw( cp->swp );
		}
		return	TRUE;
	case EventMouseSwitch:
		{
			int	x= HS_WindowGetViewSizeX(wp),
				y= HS_WindowGetViewSizeY(wp);
			ClientPack	*cp= HS_WindowGetClientPointer(wp);
			if( info->x >=x-10 && info->y >=y-10 ){
				if( info->LeftON )
					WindowResizeOperation( wp, info );
				else
					return	FALSE;
			}else if( info->y >= SCROLLYPOS ){
				info->x -= SCROLLXPOS;
				info->y -= SCROLLYPOS;
				WindowSendEvent( cp->swp, info );
			}else if( info->y > PY ){
			    if( info->LeftON ){
				int	n= (info->x+13)/30;
				if( n < cp->splitnum ){
					int		i;
					unsigned char	*ptr= cp->path;
					bankin( cp );
					for( i= 0 ; i<= n ; i++, ptr++ ){
						while( *ptr!='\\'&&*ptr!='/')
							ptr++;
					}
					*ptr= '\0';
					chgposition( cp );
					leftoffcheck( info );
				}else if( info->x < strlen(cp->splitpath)*6 ){
					WindowID	cwp;
					setmspattern();
					MS_SEL( 3 );
					leftoffcheck( info );
					MS_SEL( 0 );
					cwp= WindowGetChild( WindowRootID, info );
					if( cwp != wp ){
						info->ComBuffer= cp->path;
						info->ComData= UserString;
						info->option=EventUser;
						WindowSendEvent( cwp, info );
					}
				}
			    }else if( info->RightON )
				bankmenu( cp );
			}else{
				extern	short	dmode;
				int		m= (info->x-2-16)/16;
				UtilPack	*p;
				if( info->x < 16+2 ){
					drivemenu( cp, info );
					return	TRUE;
					/*m= 3; /*drivemenu*/
				}else
					m+= 4;
				if( m >= 7 && dmode )
					return	TRUE;
				if( m<=11 && (p=&UtilP[m],p->iconn) &&
							**(p->execptr)!= ',' ){
					if( info->RightON )
						iconmenu( cp, -1, p->execptr, p->iconn, FALSE );
					else if( info->LeftON )
						iconexec(cp,-1, p->execptr[0]);
				}
			}
		}
		return	TRUE;
	case EventClose: {
		extern short dmode;
		if( dmode )
			return	FALSE;
		}
		WindowClose( wp );
		WindowConnectionClose();
		return	TRUE;
	case EventResize:
		windowresize( HS_WindowGetClientPointer(wp),
					info->x, info->y, info->h, info->v );
		return	TRUE;
	case EventIconify: {
		static unsigned char	buf[PATHMAX];
		strcpy(buf,"KF " );
		strcat(buf,((ClientPack*)HS_WindowGetClientPointer(wp))->path);
		IconEnt( wp, (char*)buf, 9, 12 );
		}
		return	TRUE;
	case EventZoom:
		{
			ClientPack	*cp= HS_WindowGetClientPointer(wp);
			int	v= cp->maxline*cp->font_y+14+SCROLLYPOS;
			static int	zx,zy,zh,zv;
			if( !zoomflag ){
				zx= HS_WindowGetPositionX(wp);
				zy= HS_WindowGetPositionY(wp);
				zh= HS_WindowGetViewSizeX(wp);
				zv= HS_WindowGetViewSizeY(wp);
				if( v < 48 )
					v= 48;
				windowresize( cp, -1,-1,1024,v );
				zoomflag= TRUE;
			}else{
				windowresize( cp, zx, zy, zh, zv );
			}
		}
		return	TRUE;
	case EventKey:
		if( keyexec( HS_WindowGetClientPointer(wp), info, TRUE )==3 ){
			extern short	dmode,
					dialogretflag;
			if( dmode ){
				extern WindowID	Dxwp;
				int	x, y;
				WindowGetScreenPosition( Dxwp, &x, &y );
				MS_CURST( x+10, y+10 );
				dialogretflag= TRUE;
			}
		}
		return	TRUE;
	case EventUser:
		switch( info->ComData ){
		case UserString: {
			ClientPack	*cp= HS_WindowGetClientPointer(wp);
			bankin( cp );
			strcpy( cp->path, info->ComBuffer );
			chgposition( cp );
			}
			break;
		case UserStrings:
			if( B_SFTSNS() & 6 )
				user_copy( HS_WindowGetClientPointer(wp),
							info->ComBuffer );
			else
				user_move( HS_WindowGetClientPointer(wp),
							info->ComBuffer );
			break;
		case 'kf':	/* command id */
			iconexec( HS_WindowGetClientPointer(wp),
							-1, info->ComBuffer );
		}
		return	TRUE;
	}
	return	FALSE;
}

