/*	kfcopy.c Copyright 1991 H.Ogasawara	*/

#define		TEST	0

extern short	dispmode;

#if	!TEST
#include	"mmf.h"
/*#include	<doslib.h>*/

#else

#include	<stdio.h>
/*#include	<doslib.h>*/

#define		TRUE	1
#define		FALSE	0

main( argc, argv )
char	**argv;
{
	if( argc < 3 ){
		puts( "err" );
		exit( 1 );
	}
	FileCopy( argv[1], argv[2] );
}

unsigned char*
delpath( a )
unsigned char	*a;
{
	unsigned char	*p= a,
			*last= a;
	for(; *a ; a++ ){
		if( (*a == '\\' || *a == '/' || *a == ':') && a[1] )
			last= a+1;
	}
	return	last;
}
conserr( a, b )
{
	fputs( a, stdout );
	puts( b );
}
#endif

isdir( a )
unsigned char	*a;
{
	for(; *a ; a++ ){
		if( (*a == '\\' || *a == '/' || *a == ':' ) && !a[1] )
			return	TRUE;
		else if( iskanji( *a ) ){
			if( !*++a )
				break;
		}
	}
	return	FALSE;
}


FileCopy( path1, path2 )
unsigned char	*path1,
		*path2;
{
	struct FILBUF	f;
	if( FILES( &f, path1, 0x3f )<0 ){
		conserr( path1, "t@C܂" );
		return	FALSE;
	}
	if( (B_KEYSNS()&0xff) == 3 )
		return	FALSE;
	if( f.atr == 0 || (f.atr & 0x20) ){
		int		fn,
				fo,
				mode;
		unsigned char	*ptr,
				buf[80];
		if( (fn= OPEN( path1, 0 )) < 0 ){
			conserr( path1, "I[vG[" );
			return	FALSE;
		}
		if( isdir( path2 ) ){
			strcpy( buf, path2 );
			strcat( buf, f.name );
			path2= buf;
		}else if( (mode= CHMOD( path2, -1 ) )>= 0 && (mode & 0x10) ){
			unsigned char	*p= buf;
			while( *p++= *path2++ );
			for( p[-1]= '\\', path2= (unsigned char*)f.name ; *p++= *path2++ ;);
			path2= buf;
		}

		if( !strcmpi( path1, path2 ) ){
			conserr( path1, "gł" );
			CLOSE( fn );
			return	FALSE;
		}

		if( (fo= CREATE( path2, f.atr )) < 0 ){
			conserr( path2, "I[vG[" );
			CLOSE( fn );
			return	FALSE;
		}
		ptr= MALLOC( f.filelen );
		if( (unsigned int)ptr >= 0x82000000 ){
			conserr( path1, "mۂł܂" );
			CLOSE( fo );
			CLOSE( fn );
			return	FALSE;
		}else if( (unsigned int)ptr >= 0x81000000 ){
			int	maxsize= (int)ptr & 0x00ffffff,
				size;
			ptr= MALLOC( maxsize );
			do{
				int	err;
				size= READ( fn, ptr, maxsize );
				err= WRITE( fo, ptr, size );
				if( err < size ){
					conserr( path1, "fBXNςł" );
					MFREE( ptr );
					CLOSE( fo );
					CLOSE( fn );
					return	FALSE;
				}
			}while( size == maxsize );
		}else{
			if( READ( fn, ptr, f.filelen )< f.filelen ){
				conserr( path1, "ǂݍ݃G[" );
				MFREE( ptr );
				CLOSE( fo );
				CLOSE( fn );
				return	FALSE;
			}
			if( WRITE( fo, ptr, f.filelen ) < f.filelen ){
				conserr( path1, "fBXNςł" );
				MFREE( ptr );
				CLOSE( fo );
				CLOSE( fn );
				return	FALSE;
			}
		}
		FILEDATE( fo, (f.date<<16)+f.time );
		MFREE( ptr );
		CLOSE( fo );
		CLOSE( fn );
		if( dispmode )
			conscmd( "copy", path1, path2 );
	}else if( f.atr & 0x10 ){
		struct FILBUF	ff;
		unsigned char	buf1[80],
				buf2[80],
				buf22[80];
		strcpy( buf1, path1 );
		strcat( buf1, "\\" );
		strcat( buf1, "*.*" );
		strcpy( buf22, path2 );
		if( !isdir( buf22 ) ){
			if( CHMOD( buf22, -1 ) < 0 ){
				MKDIR( buf22 );
				goto	skip;
			}
			strcat( buf22, "\\" );
		}
		strcat( buf22, f.name );
		if( MKDIR( buf22 ) < 0 ){
			conserr( buf22, "fBNg܂" );
			return	FALSE;
		}
	skip:
		if( dispmode )
			conscmd( "mkdir", buf22, NULL );
		if( FILES( &ff, buf1, 0x3f ) >=0 ){
		do{
			if( *ff.name == '.' && ( ff.name[1]== '\0' ||
						ff.name[1]== '.' ) )
				continue;
			strcpy( buf1, path1 );
			strcat( buf1, "\\" );
			strcat( buf1, ff.name );
			strcpy( buf2, buf22 );
			strcat( buf2, "\\" );
			if( !(f.atr & 0x10) )
				strcat( buf2, ff.name );
			if( !FileCopy( buf1, buf2 ) )
				break;
		}while( NFILES( &ff ) >= 0 );
		}
	}else
		conserr( path1, "XLbv܂" );
	return	TRUE;
}


FileMove( path1, path2 )
unsigned char	*path1,
		*path2;
{
	struct FILBUF	f;
	if( FILES( &f, path1, 0x3f )<0 ){
		conserr( path1, "t@C܂" );
		return	FALSE;
	}
	if( (B_KEYSNS()&0xff) == 3 )
		return	FALSE;
	if( f.atr == 0 || (f.atr & 0x20) ){
		int		mode;
		unsigned char	*ptr,
				buf[80];
		if( isdir( path2 ) ){
			strcpy( buf, path2 );
			strcat( buf, f.name );
			path2= buf;
		}else if( (mode= CHMOD( path2, -1 ) )>= 0 && (mode & 0x10) ){
			unsigned char	*p= buf;
			while( *p++= *path2++ );
			for( p[-1]= '\\', path2= (unsigned char*)f.name ; *p++= *path2++ ;);
			path2= buf;
		}

		if( !strcmpi( path1, path2 ) ){
			conserr( path1, "gł" );
			return	FALSE;
		}
		if( path1[1] == ':' && path2[1] == ':' && (*path1|0x20) != (*path2|0x20) ){
			conserr( path1, "hCuقȂ܂" );
			return	FALSE;
		}

		if( RENAME( path1, path2 ) < 0 ){
			conserr( path1, "G[܂" );
			return	FALSE;
		}
		if( dispmode )
			conscmd( "move", path1, path2 );
	}else if( f.atr & 0x10 ){
		struct FILBUF	ff;
		int		fn;
		unsigned char	buf1[80],
				buf2[80],
				buf22[80];
		strcpy( buf1, path1 );
		strcat( buf1, "\\" );
		strcat( buf1, "*.*" );
		strcpy( buf22, path2 );
		if( !isdir( buf22 ) )
			strcat( buf22, "\\" );
		strcat( buf22, f.name );
		if( MKDIR( buf22 ) < 0 ){
			conserr( buf22, "fBNg܂" );
			return	FALSE;
		}
/*		if( dispmode )
			conscmd( "mkdir", buff22, NULL );*/
		CHMOD( buf22, 0x20 );
		fn= OPEN( buf22, 1 );
		FILEDATE( fn, (f.date<<16)+ f.time );
		CLOSE( fn );
		CHMOD( buf22, f.atr );
		if( FILES( &ff, buf1, 0x3f ) >=0 ){
		do{
			if( *ff.name == '.' && ( ff.name[1]== '\0' ||
						ff.name[1]== '.' ) )
				continue;
			strcpy( buf1, path1 );
			strcat( buf1, "\\" );
			strcat( buf1, ff.name );
			strcpy( buf2, buf22 );
			strcat( buf2, "\\" );
			if( !(f.atr & 0x10) )
				strcat( buf2, ff.name );
			if( !FileMove( buf1, buf2 ) )
				break;
		}while( NFILES( &ff ) >= 0 );
		}
		RMDIR( path1 );
/*		if( dispmode )
			conscmd( "rmdir", path1, NULL );*/
	}else
		conserr( path1, "XLbv܂" );
	return	TRUE;
}
