/*	makedirlist.c Copyright 1991 H.Ogasawara	*/

#include	"mmf.h"
/*#include	<doslib.h>*/
#include	<linklib.h>
#include	<string.h>

/*
000000000011111111112222222222333333333344444444445555555555
filename000000000.eee0000000000 91-09-24 06:11:32LADVSHR
filename000000000.eee0000000000 91-09-24 06:11
		      (vol)
		      <dir>
		      [link]
filename000000000.eee ->linksitearupathnohyoujilmLADVSHR
filename000000000.eee ->linksitearupathnohyoujilm
				max25char(path)
[A:\]
*/
#define		STATICBUF	0

#define		atrDIR	0x10
#define		atrVOL	0x08
#define		atrLINK	0x40

#if STATICBUF
LineFile	*linelist[MAXGETFILE];
LineFile	linebuf[MAXGETFILE];
#else
LineFile	**GL_LineP= NULL;
LineFile	*GL_BufP;
# define	linelist	GL_LineP
# define	linebuf		GL_BufP
# define	STEPBUFLEN	MAXGETFILE
static int	MaxGetFile= MAXGETFILE;
#endif

unsigned char	AttrStr[]= "LADVSHR",
		AttrnStr[]=" ------";

#if !STATICBUF
static int
dirbufalloc()
{
	int	asize= sizeof(LineFile*)* MaxGetFile,
		bsize= sizeof(LineFile)* MaxGetFile;
	if( (int)(GL_LineP= (LineFile**)MALLOC( asize+bsize )) < 0 ){
		GL_LineP= 0;
		conserr( "܂.I܂" );
		WindowSendSignal( WindowProcessID, SignalKill, 0 );
		return	FALSE;
	}
	GL_BufP= (LineFile*)((int)GL_LineP+ asize);
	KoWindowSetHeapPtr( GL_LineP, asize+bsize );
	return	TRUE;
}
#endif

/* path ͕K΃pX A:\????????\ ̌` */
static void
splitpath( cp )
ClientPack	*cp;
{
	unsigned char	*ptr= cp->splitpath,
			*str= cp->path,
			*lastp= ptr,
			*curname= str;
	short		i= 0,
			max= 2,
			kflag= FALSE;
	cp->splitnum= -1;
	for(; *str ; str++ ){
		if( !kflag && (*str == '\\' || *str == '/') ){
			for(; i < max ; i++ )
				*ptr++= ' ';
			max= 4;
			*ptr++= ' ';
			(cp->splitnum)++;
			i= 0;
			if( str[1] ){
				lastp= ptr;
				curname= str+1;
			}
			continue;
		}
		kflag= !kflag && iskanji( *str );
		if( i == 3 && kflag ){
			*ptr++= '>';
			i++;
		}else if( i < max ){
			*ptr++= *str;
			i++;
		}
	}
	strcpy( lastp, curname );
	strcat( lastp, cp->mask );
}

static int
namesort( a, b )
LineFile	**a, **b;
{
	return	strcmp( (*a)->str, (*b)->str );
}
static int
rvnamesort( a, b )
LineFile	**a, **b;
{
	return	strcmp( (*b)->str, (*a)->str );
}
static int
namesort2( a, b )
LineFile	**a, **b;
{
	return	strcmpi( (*a)->str, (*b)->str );
}
static int
rvnamesort2( a, b )
LineFile	**a, **b;
{
	return	strcmpi( (*b)->str, (*a)->str );
}
static int
rvdatesort( a, b )
LineFile	**a, **b;
{
	return	strcmp( (*a)->str+32, (*b)->str+32 );
}
static int
datesort( a, b )
LineFile	**a, **b;
{
	return	strcmp( (*b)->str+32, (*a)->str+32 );
}
/* input= cp->path */
void
makedirlist( cp )
ClientPack	*cp;
{
	struct FILBUF	f;
	unsigned char	buf[PATHMAX];
	LineFile	*lp, **lpp;
	int		num= 0;
#if !STATICBUF
	if( !GL_LineP ){
		if( !dirbufalloc() )
			return;
	}
#endif
	lp= linebuf,
	lpp= linelist;
	strcpy( buf, cp->path );
	strcat( buf, cp->mask );
	if( FILES( &f, buf, cp->byte1 ) >= 0 ){
		do{
			unsigned char	*ptr= lp->str;
			if( *f.name == '.' && (f.name[1] == '\0' ||
				(f.name[1] == '.' && f.name[2] == '\0' ) ) )
				 	continue;
			if( f.atr & cp->byte2 )
				continue;
			if( num >= MaxGetFile ){
				goto	ForceExit;
			}
			lp->attr= FCOLOR;
			*lpp++= lp;
			num++;

/****** Ȃ}N *****/

#define	NAMESET()	{		\
	unsigned char	*name= f.name;	\
	int		i;		\
	for( i= 0 ; *name ; i++ )	\
		*ptr++= *name++;	\
	for(; i < 21 ; i++ )		\
		*ptr++= ' ';		\
			}
#define	NAMESET2()	{		\
    unsigned char	*name= f.name;	\
    int		i;		\
    for( i= 0 ; *name ; i++ ){	\
	if( *name == '.' ){	\
	    short	j;	\
	    for( j= SYSTEMICON ; j< iconnum ; j++ ){	\
		if( (name[1]|0x20) == IconP[j].ext[0] && (\
		      (!name[2] && IconP[j].ext[1]=='\n') || (		\
			(name[2]|0x20) == IconP[j].ext[1] &&(\
			  (!name[3] && IconP[j].ext[2]=='\n') ||\
			    (name[3]|0x20) == IconP[j].ext[2]\
			)	\
		    )		\
		)){			\
					lp->icon= j+1;	\
					break;		\
				}			\
			}				\
		}					\
		*ptr++= *name++;			\
	}						\
	for(; i < 21 ; i++ )		\
		*ptr++= ' ';		\
			}
/***** end of macro *****/
			if( f.atr & atrDIR ){
				unsigned char	*str= (void*)" <dir>    ";
				NAMESET();
				lp->icon= iDIR;
				while( *str )
					*ptr++= *str++;
			}else if( f.atr & atrVOL ){
				unsigned char	*str= (void*)" (vol)    ";
				NAMESET();
				lp->icon= iOFF;
				while( *str )
					*ptr++= *str++;
			}else if( ( f.atr == 0 && f.filelen == 256 )||
							(f.atr & atrLINK) ){
				unsigned char	*str= (void*)" [link]   ";
				extern short	linkdisp;
				lp->icon= iLINK;
				NAMESET2();
				if( linkdisp && OpenLinkLib() ){
					LINKBUF	lb;
					short	i;
					lb.norec= linkdisp/*DefaultNorec*/;
					strcpy( buf, cp->path );
					strcat( buf, f.name );
					GetLinkPath( (char*)buf, &lb );
					*ptr++= ' ';
					*ptr++= '-';
					*ptr++= '>';
					str= (unsigned char*)lb.path;
					for( i= 0 ; i<25 && *str ; i++ )
						*ptr++= *str++;
					for(; i<25 ; i++ )
						*ptr++= ' ';
					lp++;
				/*	goto	attrset;	*/
				}else{
					while( *str )
						*ptr++= *str++;
				}
			}else{
				lp->icon= iOFF;
				NAMESET2();
				IUSING( f.filelen, 10, ptr );
				ptr+= 10;
			}
			lp++;
			*ptr++= ' ';
			{
				int	a;
				a= f.date;
				ptr= (unsigned char*)DATESTR(
					(((a&0xfe00)+(1980<<9))<<7)+
					((a&0x01e0)<<3)+
					(a&0x001f)+0x30000000, ptr );
				*ptr++= ' ';
/*
				a= f.time;
				ptr= (unsigned char*)TIMESTR(
					((a&0xf800)<<5)+
					((a&0x07e0)<<3)+
					((a&0x1f)<<1), ptr );
*/
				a= f.time >> 11;			/* hour */
				*ptr++= a / 10 + 0x30;
				*ptr++= a % 10 + 0x30;
				*ptr++= ':';
				a= ( f.time >> 5 ) & 63;	/* minute */
				*ptr++= a / 10 + 0x30;
				*ptr++= a % 10 + 0x30;
			}
/*
		attrset:
			{
				short	i, j= f.atr;
				for( i= 0 ; i< 7 ; i++, j+= j )
					*ptr++=((j & 64 )?AttrStr:AttrnStr)[i];
			}
*/
			*ptr= '\0';

		}while( NFILES( &f ) >= 0 );
	}
	cp->cursor= num?0:-1;
	cp->maxline= num;
	splitpath( cp );
	cp->line= linelist;
	if( cp->sortmode ){
		static int	(*sortlist[])()= {
			namesort2, rvnamesort2, namesort,
			rvnamesort, datesort, rvdatesort
		};

		qsort( linelist, num, sizeof(LineFile*), sortlist[ cp->sortmode -1 ] );
	}
	return;
ForceExit:
	/*conserr( "DIR̃t@CftHg̃GgI[o[܂\ngC܂BX҂\n" );*/
	MaxGetFile+= STEPBUFLEN;
	if( dirbufalloc() )
		makedirlist( cp );
}

