/*	mmf.c Copyright 1991 H.Ogasawara	*/

#include	"mmf.h"
/*#include	<doslib.h>*/
#include	<corlib.h>
#include	<string.h>

#define		WINDOWTITLENAME		"KF 1.32 twin"

static ClientPack	cp;

int	WindowHeapSize= 0;
short	linkdisp= FALSE,
	errormode= TRUE,
	dispmode= FALSE,
	windowbank= TRUE;
int	F_G_Color= 9,
	B_G_Color= 1;

void
WindowMain( argc, argv )
int	argc;
char	**argv;
{
	struct NAMECKBUF	nm;
	char	*fname= ".";
	int	x= DEFAULTPOSX,
		y= DEFAULTPOSY,
		h= DEFAULTSIZEX,
		v= DEFAULTSIZEY;
	argc= AnalyzeArgs( argc, argv, &x, &y, &h, &v );
	cp.font_y= DEFAULTFONTSIZE;
	cp.sortmode=/* sortNOT;*/
	cp.defsort= sortNAME;
	cp.attrsafety= 4;
	cp.byte1= 0x3f;
	cp.byte2= 0x0e;
	cp.askmode= TRUE;
	cp.automove= AUTOASK;
	while( --argc ){
		if( **++argv == '-' ){
			switch( *++*argv ){
			case 'f':
				cp.font_y= atoi2( (*argv)+1 );
				break;
			case 's':
				cp.defsort= cp.sortmode= atoi2( (*argv)+1 )&7;
				break;
			case 'a':
				F_G_Color= atoi2( (*argv)+1 );
				B_G_Color= (F_G_Color&8) ? F_G_Color&3 : 0;
				break;
			case 'A':
				cp.attrsafety= 0;
				break;
			case 'b':
				{
					int	i;
					cp.byte1= (i= atoi2((*argv)+1)) & 0x3f;
					cp.byte2= (i>>8)&0x3f;
				}
				break;
			case 'l':
				linkdisp= TRUE;
				if( (*argv)[1] )
					linkdisp= 20/*DefaultNorec*/;
				break;
			case 'k':
				cp.askmode= FALSE;
				break;
			case 'u':
				cp.automove= atoi2( (*argv)+1 );
				break;
			case 'w':
				windowbank= FALSE;
				break;
			case 'd':
				dispmode= TRUE;
				break;
			case 'z':
				conserr( NULL, " Copyright (C) 1991-1995 H.Ogasawara" );
			}
		}else {
			char	*ptr;
			ptr= strcpyr( fname, *argv );
			if( *(ptr - 1) != ':' ){
				*ptr++= '/';
				*ptr= NULL;
			}
		}
	}
	NAMECK( (void*)fname, &nm );
	strcpy( cp.path, nm.drive );
	strcpy( cp.mask, "*.*" );
	if( !readicon() ){
		WindowSendSignal( WindowProcessID, SignalKill, 0 );
		return;
	}
	drivemenuinit();
	makedirlist( &cp );
	setclient= &cp;
	WindowTitleOpen( x, y, h, v, NULL, WINDOWTITLENAME,
				Resize|Close|Icon|Push|Zoom, BaseExec );
}
