/* Copyright 1991 H.Ogasawara  popup.c */
#include	"mmf.h"

#define	font	12

struct Menu	{
	short		ReturnCode;
	short		PopUpItems;
	unsigned char	**PopUpItem;
};

static	int
PopUpExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	if( info->option == EventRedraw ){
		short	i;
		int	h;
		struct Menu *mp=(struct Menu*)HS_WindowGetClientPointer(wp);
		DrawBuf	dbuf[32],
			*bp= dbuf;
		h= HS_WindowGetViewSizeX(wp);
		DrawSetClear( bp++, BACKCOLOR );
		for( i= 0 ; i < mp->PopUpItems ; i++ ){
			unsigned char	*p= mp->PopUpItem[i];
			DrawSetSymbol( bp++, 4, font*i, (char*)(*p == '~' ?
				p+1 : p),  FCOLOR, font);
		}
		if( (i= mp->ReturnCode) >= 0 && *mp->PopUpItem[i] != '~' ){
			i*= font;
			DrawSetLine(bp++, 0, i, h-1, i+font-1,RCOLOR|OptionXor,OptionFill);
		}
		WindowDraw( wp, dbuf, bp-dbuf );
	}
	return	TRUE;
}

int
PUmenu( cp, nn, item, items, flag )
ClientPack	*cp;
unsigned char	**item;
int		nn,
		items,
		flag;
{
	int		sx, sy;
	WindowID	wp;
	EventInfo	info;
	DrawBuf		buf[2];
	short		h= 0;
	struct Menu	mp;

	mp.PopUpItem= item;
	mp.PopUpItems= items;
	{
		unsigned int	x= MS_CURGT(),
				y= x & 0xffff;
		short	i;
		for( i = 0 ; i < items ; ++i ){
			unsigned char	*p= item[i];
			short	n= strlen( *p == '~' ? p+1 : p );
			if( n > h )
				h= n;
		}
		h= h*font/2+8;
		wp= WindowSimpleOpen( (x>>16)-2, (y)+1, h, items*font, NULL, PopUpExec );
		HS_WindowGetClientPointer(wp)= &mp;
	}
	WindowGetScreenPosition( wp, &sx, &sy );
	WindowGetEventInfo( &info );
	{
		short	i;
		i= mp.ReturnCode= (info.y -sy)/font;
		if( i < 0 || i >= items )
			mp.ReturnCode= -1;
		else if( i>=0 && i<items && *item[i] == '~' )
			mp.ReturnCode= -1;
	}
	WindowRedraw( wp );

	info.LeftStat= info.RightStat= TRUE;
	WindowGetScreenPosition( wp, &sx, &sy );
	for(;;){
		if( WindowGetEventInfo( &info ) ){
			short	n;
			info.x -= sx;
			info.y -= sy;
			n= info.y/font;
			if( info.y < 0 || n >= items || info.x < 0 || info.x > h )
				n= -1;
			else if( n>=0 && n<items && *item[n] == '~' )
				n= -1;
			if( info.x > h && mp.ReturnCode >= 0 ){
				UtilPack	up;
				int		p;
				if( p= strchr( item[mp.ReturnCode], 0x1c ) ){
					if( makemenu( p+2, &up ) && iconmenu(
					cp, nn, up.execptr, up.iconn, TRUE )){
						WindowClose( wp );
						return	-1;
					}
				}
			}
			if( !info.RightStat || info.LeftStat ){
/*				mp.ReturnCode = n;*/
				WindowClose( wp );
				return	n;
			}else if( mp.ReturnCode != n ){
				short	a= font*n;
				DrawSetLine( buf, 0, a, h-1, a+font-1, RCOLOR+OptionXor, OptionFill );
				a= font*mp.ReturnCode;
				DrawSetLine( buf+1, 0, a, h-1, a+font-1, RCOLOR+OptionXor, OptionFill );
				WindowDraw( wp, buf, 2 );
				mp.ReturnCode= n;
			}
			if( flag && info.x < 0 ){
				WindowClose( wp );
				return	-1;
			}
		}
	}
}

