/*	command.c Copyright 1991 H.Ogasawara	*/

#include	"mmf.h"
/*#include	<doslib.h>*/

int		(*DirExec1)(),
		(*DirExec2)();
static int	allsize;
short		ct_files,
		ct_dirs;
extern short	dispmode;

/* KwfBNgT */
getfname( path )
unsigned char	*path;
{
	unsigned char	fbuf[PATHMAX],
			*ptr= fbuf;
	struct FILBUF	f;
	while( *ptr++ = *path++ );
	strcpy( --ptr, "*.*" );
	if( FILES( &f, fbuf, 0x3f )>= 0 ){
		do{
			unsigned char	*p1, *p2;
			short		i;
			if( (B_KEYSNS() & 0xff) == 3 )
				return	FALSE;
			if( *f.name == '.' &&
				( f.name[1] == '\0' || f.name[1] == '.' ) )
				continue;
			for(p1=(unsigned char*)f.name, p2=ptr ; *p2++=*p1++ ;);
			if( i= (*DirExec1)( &f, fbuf ) ){
				if( i< 0 )
					return	FALSE;
				p2[-1]= '\\';
				*p2= '\0';
				if( !getfname( fbuf ) )
					return	FALSE;
				p2[-1]= '\0';
				(*DirExec2)( &f, fbuf );
			}
		}while( NFILES( &f ) >= 0 );
	}
	return	TRUE;
}

static
sizeexec1( f, a )
struct FILBUF	*f;
unsigned char	*a;
{
	if( f->atr & 0x10 ){
		ct_dirs++;
		return	TRUE;
	}else{
		allsize+= f->filelen;
		ct_files++;
		return	FALSE;
	}
}

/* 폜 */
static
deleteexec1( f, a )
struct FILBUF	*f;
unsigned char	*a;
{
	if( f->atr & 0x10 )
		return	TRUE;
	if( f->atr & 1 )
		CHMOD( a, f->atr & 0xfe );
	if( DELETE( a ) < 0 )
		conserr( a, "XLbv܂" );
	else if( dispmode )
		conscmd( "del", a, NULL );
	return	FALSE;
}
deleteexec2( f, a )
struct FILBUF	*f;
unsigned char	*a;
{
	if( f->atr & 1 )
		CHMOD( a, f->atr & 0xfe );
	if( RMDIR( a ) < 0 )
		conserr( a, "XLbv܂" );
	else if( dispmode )
		conscmd( "rmdir", a, NULL );
}

/* fBNgTGg[ */
void
allent( path, exec1, exec2 )
unsigned char	*path;
int		(*exec1)(),
		(*exec2)();
{
	unsigned char	buf[PATHMAX];
	strcpy( buf, path );
	strcat( buf, "\\" );
	DirExec1= exec1;
	DirExec2= exec2;
	getfname( buf );
}

/* fBNgTCY߂ */
getdirsize( path )
unsigned char	*path;
{
	extern int	dummyexec();
	allsize= 0;
	ct_files= 0;
	ct_dirs= 0;
	allent( path, sizeexec1, dummyexec );
	return	allsize;
}


/* t@C폜 */
file_delete( cp, n )
ClientPack	*cp;
int		n;
{
	char	buf[80];
	short	num= quickmark( cp, n );
	void		*mem;
	unsigned char	**pp;
	if( num<0 )
		return;
	pp= mem= (void*)makefilelist( cp );
	if( !mem )
		return;
	strcpy( buf, "폜:" );
	if( num>1 ){
		IUSING( num, 3, buf+5 );
		strcat( buf, " files" );
	}else{
		strcat( buf, delpath(*pp));/*cutfilename(cp->line[n]->str));*/
	}
	if( YesNo( buf, "폜܂B낵łH" ) ){
		for(; *pp ; pp++ ){
			short	err, mode;
		delete:
			if( DELETE( *pp ) >= 0 ){
				if( dispmode )
					conscmd( "del", *pp, NULL );
				continue;
			}
			mode= CHMOD( *pp, -1 );
			strcpy( buf, "폜:" );
			strcat( buf, delpath(*pp) );
			if( mode & 1 ){
				if( YesNo( buf, "ǂݏopłB폜܂H" ) ){
					if( CHMOD( *pp, mode & 0xfe )>=0 )
						goto	delete;
				}
			}else if( mode & 0x10 ){
				if( (err= RMDIR( *pp ))>= 0 ){
					if( dispmode )
						conscmd( "rmdir", *pp, NULL );
					continue;
				}
				if( err == -21 && YesNo( buf,
						"fBNgɃt@CcĂ܂" ) ){
					allent( *pp, deleteexec1, deleteexec2);
					RMDIR( *pp );
					if( dispmode )
						conscmd( "rmdir", *pp, NULL );
					continue;
				}
			}
			conserr( *pp, "XLbv܂" );
		}
		resetposition( cp, TRUE );
	}
	WindowMemoryFree( mem );
	if( num == 0 )
		markclear( cp, 8 );	/* quick off */
}

pushd( path )
unsigned char	*path;
{
	static short		curdrv;
	static unsigned char	curdir[PATHMAX];
	if( path ){
		CURDIR( curdrv= CURDRV()+1, curdir+3 );
		curdir[0]= curdrv+'A'-1;
		curdir[1]= ':';
		curdir[1]= '\\';
		CHGDRV( *path-1 & 0x1f );
		CHDIR( path );
	}else{
		CHGDRV( curdrv-1 );
		CHDIR( curdir );
	}
}
/* t@CRs[ */
file_copy( cp, n )
ClientPack	*cp;
int		n;
{
	unsigned char	buf[80],
			pbuf[PATHMAX];
	short		num= quickmark( cp, n );
	void		*mem;
	unsigned char	**pp;

	if( num < 0 )
		return;
	pp= mem= (void*)makefilelist( cp );
	if( !mem )
		return;

	strcpy( buf, "Rs[:" );
	if( num > 1 ){
		IUSING( num, 3, buf+7 );
		strcat( buf, " files" );
	}else
		strcat( buf, delpath( *pp ) );
	if( num <= 1 ){
		strcpy( ibuf, delpath( *pp ) );
		if( !Dialog( cp, buf, "]Jĉ(̓Rs[)",
								dialogINPUT ) )
			goto	copyexit;
		if( !*ibuf )
			strcpy( ibuf, delpath( *pp ) );
		strcpy( pbuf, cp->path );
		strcat( pbuf, ibuf );
		FileCopy( *pp, pbuf );
	}else{

		*ibuf= '\0';
		if( !Dialog( cp,buf,"Rs[Jĉ(܂PATH)",
								dialogINPUT ) )
			goto	copyexit;
		if( *ibuf ){
			struct	NAMECKBUF	n;
			pushd( cp->path );
			NAMECK( ibuf, &n );
			strcat( n.name, n.ext );
			strcat( n.path, n.name );
			if( !isdir( n.drive ) )
				strcat( n.path, "\\" );
			strcpy( pbuf, n.drive );
			pushd( NULL );	/* popd */
		}else
			strcpy( pbuf, cp->path );
		for(; *pp ; pp++ )
			if( !FileCopy( *pp, pbuf ) )
				break;
	}
	resetposition( cp, TRUE );
copyexit:
	WindowMemoryFree( mem );
}
/* Ot@CRs[ */
user_copy( cp, pp )
ClientPack	*cp;
unsigned char	**pp;
{
	unsigned char	buf[80],
			pbuf[PATHMAX];
	short		num,
			nocheck= B_SFTSNS() & 1;

	for( num= 0 ; pp[num] ; num++ );

	strcpy( buf, "Rs[:" );
	if( num > 1 ){
		IUSING( num, 3, buf+7 );
		strcat( buf, " files" );
	}else
		strcat( buf, delpath( *pp ) );
	if( num <= 1 ){
		strcpy( ibuf, delpath( *pp ) );
		if( !nocheck )
			if( !Dialog( cp, buf,
		"Rs[܂(]ύX,̓Rs[)", dialogINPUT ) )
				return;
		if( !*ibuf )
			strcpy( ibuf, delpath( *pp ) );
		strcpy( pbuf, cp->path );
		strcat( pbuf, ibuf );
		FileCopy( *pp, pbuf );
	}else{

		*ibuf= '\0';
		if( !nocheck )
			if( !Dialog( cp, buf, "Rs[܂(]ύX)",
								dialogINPUT ) )
				return;
		if( *ibuf ){
			struct	NAMECKBUF	n;
			pushd( cp->path );
			NAMECK( ibuf, &n );
			strcat( n.name, n.ext );
			strcat( n.path, n.name );
			if( !isdir( n.drive ) )
				strcat( n.path, "\\" );
			strcpy( pbuf, n.drive );
			pushd( NULL );	/* popd */
		}else
			strcpy( pbuf, cp->path );
		for(; *pp ; pp++ )
			if( !FileCopy( *pp, pbuf ) )
				break;
	}
	/*resetposition( cp, TRUE );*/
	sendprocess( cp, 0, "kf.win", 2 );	/* broadcast ? */
						/* Refresh all */
}

/* Ot@C[u */
user_move( cp, pp )
ClientPack	*cp;
unsigned char	**pp;
{
	unsigned char	buf[80],
			pbuf[PATHMAX];
	short		num,
			nocheck= B_SFTSNS() & 1;

	for( num= 0 ; pp[num] ; num++ );
	strcpy( buf, "ړ:" );
	if( num > 1 ){
		IUSING( num, 3, buf+7 );
		strcat( buf, " files" );
	}else
		strcat( buf, delpath( *pp ) );

/*	strcpy( ibuf, delpath( *pp ) );*/
	*ibuf= '\0';
	if( !nocheck )
		if( !Dialog( cp, buf,"ړ܂(ړύX\)",
								dialogINPUT ) )
			return;
	if( *ibuf ){
		struct	NAMECKBUF	n;
		pushd( cp->path );
		NAMECK( ibuf, &n );
		strcat( n.name, n.ext );
		strcat( n.path, n.name );
		if( !isdir( n.drive ) )
			strcat( n.path, "\\" );
		strcpy( pbuf, n.drive );
		pushd( NULL );	/* popd */
	}else
		strcpy( pbuf, cp->path );
	if( (*pp)[0] != pbuf[0] ){
		if( !nocheck )
			if( !YesNo( buf, "hCuقȂ܂BRs[܂H" ) )
				return;
		for(; *pp ; pp++ )
			if( !FileCopy( *pp, pbuf ) )
				break;
	}else{
		for(; *pp ; pp++ )
			if( !FileMove( *pp, pbuf ) )
				break;
	}
	sendprocess( cp, 0, "kf.win", 2 );	/* broadcast ? */
}

/* t@C[u */
file_move( cp, n )
ClientPack	*cp;
int		n;
{
	unsigned char	buf[80],
			pbuf[PATHMAX];
	short		num= quickmark( cp, n );
	void		*mem;
	unsigned char	**pp;

	if( num < 0 )
		return;

	pp= mem= (void*)makefilelist( cp );

	if( !mem )
		return;

	strcpy( buf, "ړ:" );
	if( num > 1 ){
		IUSING( num, 3, buf+7 );
		strcat( buf, " files" );
	}else
		strcat( buf, delpath( *pp ) );

	*ibuf= '\0';
	if( !Dialog( cp, buf, "ړJĉ(܂PATH)",
								dialogINPUT ) )
		goto	copyexit;
	if( *ibuf ){
		struct	NAMECKBUF	n;
		pushd( cp->path );
		NAMECK( ibuf, &n );
		strcat( n.name, n.ext );
		strcat( n.path, n.name );
		if( !isdir( n.drive ) )
			strcat( n.path, "\\" );
		strcpy( pbuf, n.drive );
		pushd( NULL );	/* popd */
	}else
		strcpy( pbuf, cp->path );
	if( (*pp)[0] != pbuf[0] ){
		if( !YesNo( buf, "hCuقȂ܂BRs[܂H" ) )
			goto	copyexit;
		for(; *pp ; pp++ )
			if( !FileCopy( *pp, pbuf ) )
				break;
	}else{
		for(; *pp ; pp++ )
			if( !FileMove( *pp, pbuf ) )
				break;
	}
	resetposition( cp, TRUE );
copyexit:
	WindowMemoryFree( mem );
}



