/*	command.c Copyright 1991 H.Ogasawara	*/

#include	"mmf.h"
/*#include	<doslib.h>*/

/* iHt@C𓾂 */
unsigned char *
delpath( str )
unsigned char	*str;
{
	unsigned char	*name= str;
	for(; *str ; str++ ){
		if( (*str == '\\' || *str == '/' || *str == ':') && str[1] )
			name= str+1;
		else if( iskanji(*str) && str[1] )
			str++;
	}
	return	name;
}

/* R\[ɃG[bZ[Wo͂ */
conserr( file, mess )
unsigned char	*file,
		*mess;
{
	extern short	errormode;
	if( !errormode )
		return;
	ConsoleOpen();
	ConsolePrint( PRGNAME_C );
	if( file ){
		ConsoleChar( '\'' );
		ConsolePrint( (char*)delpath(file) );
		ConsoleChar( '\'' );
	}
	ConsolePrint( (char*)mess );
	ConsolePrint( "\r\n" );
}
/* R\[Ɏs\ */
conscmd( cmd, file1, file2 )
unsigned char	*file1,
		*file2,
		*cmd;
{
	ConsoleOpen();
	if( cmd )
		ConsolePrint( cmd );
	if( file1 ){
		ConsoleChar( ' ' );
		ConsolePrint( file1 );
	}
	if( file2 ){
		ConsoleChar( ' ' );
		ConsolePrint( file2 );
	}
	ConsolePrint( "\r\n" );
}

/* t@Coă_CAObZ[W쐬 */
fdialog( cp, mes1, file, mes2, mode )
ClientPack	*cp;
unsigned char	*mes1,
		*file,
		*mes2;
int		mode;
{
	unsigned char	buf[PATHMAX];
	strcpy( buf, mes1 );
	strcat( buf, delpath( file ) );
	return	Dialog( cp, buf, mes2, mode );
}

/* t@CύX */
file_rename( cp, n )
ClientPack	*cp;
int		n;
{
	unsigned char	pbuf[PATHMAX];
	void		*mem;
	unsigned char	**pp;
	if( quickmark( cp, n ) < 0 )
		return;
	pp= mem= (void*)makefilelist( cp );
	for(; *pp ; pp++ ){
		short	err, mode;
		strcpy( ibuf, delpath( *pp ) );
		if( !fdialog(cp,"OύX:", *pp,
				"VO͂ĉ", dialogINPUT ))
			break;
		strcpy( pbuf, cp->path );
		strcat( pbuf, delpath( ibuf ) );
		if( RENAME( *pp, pbuf ) >= 0 )
			continue;
		mode= CHMOD( *pp, -1 );
		if( mode >=0 && (mode & 1) ){
			if( fdialog(cp,	"OύX:", *pp,
					"ǂݏopłBs܂H",
					dialogYESNO )){
				if( CHMOD( *pp, mode & 0xfe )>=0 ){
					err= RENAME( *pp, pbuf );
					CHMOD( *pp, mode );
					if( err >= 0 )
						continue;
				}
			}
		}
		conserr( *pp, "XLbv܂" );
	}
	WindowMemoryFree( mem );
	resetposition( cp, TRUE );
}

gettimeline( file, buf )
unsigned char	*file,
		*buf;
{
	int		a;
	unsigned char	*p= buf;
	struct FILBUF	f;
	/* 91-09-28 19:56:31 */
	if( FILES( &f, file, 0x3f )>= 0 ){
		a= f.date;
		p= (unsigned char*)DATESTR( (((a&0xfe00)+(1980<<9))<<7)+
				((a&0x01e0)<<3)+ (a&0x001f)+0x30000000, p );
		*p++= ' ';
		a= f.time;
		p= (unsigned char*)TIMESTR( ((a&0xf800)<<5)+ ((a&0x07e0)<<3)+
							((a&0x1f)<<1), p );
		*p= '\0';
		if( buf[9] == ' ' )
			buf[9]= '0';
		return	f.atr;
	}
	return	-1;
}

settimeline( file, str )
unsigned char	*file,
		*str;
{
	unsigned char	*p= (unsigned char*)strchr( str, ' ' );
	int		date,
			a;
	if( !p )
		return	FALSE;
	*p= '\0';
	a= DATECNV( str );
	*p= ' ';
	if( a < 0 )
		return	FALSE;
	date= (((a&0xfff0000)-1980*65536)<<9)+((a&0xf00)<<13)+((a&0xff)<<16);
	if( (a= TIMECNV( p+1 )) < 0 )
		return	FALSE;
	date+= ((a&0xff0000)>>5)+((a&0xff00)>>3)+((a&0xfe)>>1);
	if( (a= OPEN( file, 1 )) < 0 )
		return	2;
	FILEDATE( a, date );
	CLOSE( a );
	return	TRUE;
}


/* ^CX^vύX */
file_time( cp, n )
ClientPack	*cp;
int		n;
{
	void		*mem;
	unsigned char	**pp;
	if( quickmark( cp, n ) < 0 )
		return;
	pp= mem= (void*)makefilelist( cp );
	for(; *pp ; pp++ ){
		short	err, mode;
		if( (mode= gettimeline( *pp, ibuf ))<0 )
			goto	skip;
	retry:
		if( !fdialog(cp,"ѽߕύX:", *pp,
				 "Ƀ}EX̍NbNg܂",
								dialogTIME ) )
			break;
		if( mode & 0x10 ){
			if( CHMOD( *pp, 0x20 )<0 )
				goto	skip;
		}
		if( mode & 1 ){
			if( fdialog(cp, "ѽߕύX:", *pp,
				     "ǂݏopłBs܂H",
				     			dialogYESNO ) )
				if( CHMOD( *pp, 0x20 )<0 )
					goto	skip;
		}
		if( (err= settimeline( *pp, ibuf )) == FALSE ){
			conserr( *pp, "ݒs\" );
			goto	retry;
		}
		if( mode & 0x11 )
			CHMOD( *pp, mode );
		if( err )
			continue;
	skip:
		conserr( *pp, "XLbv܂" );
	}
	WindowMemoryFree( mem );
	resetposition( cp, TRUE );
}

/* t@CAgr[gύX */
file_attr( cp, n )
ClientPack	*cp;
int		n;
{
	void		*mem;
	unsigned char	**pp;
	if( quickmark( cp, n )<0 )
		return;
	for( pp= mem= (void*)makefilelist( cp ); *pp ; pp++ ){
		short		i,
				j,
				attr;
		unsigned char	*p;
		extern unsigned char	AttrStr[],
					AttrnStr[];
		if( (j= attr= CHMOD( *pp, -1 )) < 0 ){
			conserr( *pp, "XLbv܂" );
			continue;
		}
		for( i= 0 ; i< 7 ; i++, j+= j )
			ibuf[i]= ((j & 0x40) ? AttrStr : AttrnStr)[i];
		ibuf[7]= '\0';
	retry:
		if( !fdialog(cp,"ޭĕύX:", *pp,
				"}EX̍NbNŔ]ł܂",
							dialogATTR ) )
			break;
		for( cp->attrsafety? (attr&=0x78):(attr=0),p=ibuf ; *p ; p++ ){
			if( i= strchr( AttrStr+cp->attrsafety, *p & 0xdf ) )
				attr|= 1<< ((int)AttrStr+6-i);
		}
		if( CHMOD( *pp, attr&0x7f )< 0 ){
			conserr( *pp, "ݒs\" );
			goto	retry;
		}
	}
	WindowMemoryFree( mem );
	resetposition( cp, TRUE );
}


/* fBNg쐬 */
file_mkdir( cp )
ClientPack	*cp;
{
	unsigned char	buf[PATHMAX];
	*ibuf= '\0';
retry:
	if( !Dialog( cp,"VKfBNg̍쐬",
			"fBNg͂ĉ", dialogINPUT ))
			return;
	strcpy( buf, cp->path );
	strcat( buf, ibuf );
	if( MKDIR( buf )<0 ){
		conserr( ibuf, "쐬s\" );
		goto	retry;
	}
	resetposition( cp, TRUE );
}


/* t@CTCY̍v߂ */
file_size( cp, n )
ClientPack	*cp;
int		n;
{
	void		*mem;
	unsigned char	**pp;
	int		size= 0;
	short		dirnum= 0,
			filenum= 0;
	struct FILBUF	f;
	unsigned char	buf[40];
	extern short	ct_dirs,
			ct_files;
	if( quickmark( cp, n ) < 0 )
		return;
	pp= mem= (void*)makefilelist( cp );
	for(; *pp ; pp++ ){
		FILES( &f, *pp, 0x3f );
		if( f.atr & 0x10 ){
			size+= getdirsize( *pp );
			dirnum+= ct_dirs+1;
			filenum+= ct_files;
		}else{
			size+= f.filelen;
			filenum++;
		}
	}
		/*    OOOOOOOOOOOOOOOOOOOO  */
		/*    01234567890123456789012345678901234567890	*/
	strcpy( buf, "000000000000 Byte 0000 Files 0000 Dirs" );
	IUSING( size, 12, buf );
	if( filenum <= 1 )
		buf[27]= ' ';
	if( dirnum <= 1 )
		buf[37]= ' ';
	IUSING( filenum, 4, buf+18 );
	IUSING( dirnum, 4, buf+29 );
	buf[12]= buf[22]= buf[33]= ' ';
	WindowMemoryFree( mem );
	if( YesNo( "t@CTCY̑a", buf ) )
		markclear( cp, 8 );
}

