/*	dialog.c Copyright 1991 H.Ogasawara	*/
#define	TEST	0

#if	TEST
#include	<corlib.h>
#else
#include	"mmf.h"
#endif
/*#include	<doslib.h>*/

#define		COMX	10
#define		COMY	10		/* 10 */
#define		COMFONT	16
#define		MESX	10
#define		MESY	(10+24)		/* 34 */
#define		MESFONT	12
#define		YESX	32
#define		YESY	(10+64-4)	/* 70 */
#define		YESFONT	16
#define		NOX	(32+64+16)
#define		NOY	(10+64-4)
#define		NOFONT	16

#define		INPX	10
#define		INPY	(50)
#define		IMAX	38
#define		IFONT	12

#define		LINE	(55)

#define		WINX	259
#define		WINY	156
#define		WINH	250
#define		WINV	100

#define		IN(x1,y1,x2,y2)	(info->x>=(x1)&& info->x<=(x2)&&	\
				info->y>=(y1)&& info->y<=(y2))

#define		YESNO	dialogYESNO
#define		INPUT	dialogINPUT
#define		TIME	dialogTIME
#define		ATTR	dialogATTR

WindowID		Dxwp;

static unsigned char	*message,
			*commandname;
short			dmode=	YESNO,
			dialogretflag= FALSE;
static int		dialy= 0;
static InputClass	Input;

unsigned char		ibuf[IMAX*2];

#define		DIALOGMENU	6
static unsigned char	*dialogmenu[]= {
		"y[Xg",
		"sNA",
		"ر&߰",
		" 啶",
		" ",
		"  ړ"
	};

DialogExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	if( info->option == EventRedraw ){
		DrawBuf	dbuf[14],
			*dp= dbuf;
		DrawSetClear( dp++, BACKCOLOR );
		DrawSetSymbol( dp++, COMX, COMY, (char*)commandname,
					FCOLOR|AttrHighLight, COMFONT );
		DrawSetSymbol( dp++, MESX, MESY-dialy, (char*)message,
						FCOLOR, MESFONT );
		DrawSetSymbol( dp++, YESX, YESY+dialy,
				dmode == YESNO ?"s         ([Y]/[N])":
						"s      ~   (RET/ESC)",
					FCOLOR, YESFONT );
		DrawSetLine( dp++, YESX-4, YESY-4+dialy, YESX+YESFONT*2+3,
				YESY+YESFONT+4+dialy, ShadowUp, OptionShadow );
		DrawSetLine( dp++, YESX-2, YESY-2+dialy, YESX+YESFONT*2+1,
				YESY+YESFONT+2+dialy,ShadowDown,OptionShadow );
		DrawSetLine( dp++, NOX-4, NOY-4+dialy, NOX+NOFONT*2+3,
				NOY+NOFONT+4+dialy, ShadowUp, OptionShadow );
		DrawSetLine( dp++, NOX-2, NOY-2+dialy, NOX+NOFONT*2+1,
				NOY+NOFONT+2+dialy, ShadowDown, OptionShadow );
		DrawSetLine( dp++, 1, 1, WINH-2, WINV-2, ShadowDown,
							OptionShadow );
		if( dmode == YESNO )
		    DrawSetLine( dp++, 6, LINE, WINH-7, LINE+1, ShadowDown,
							OptionShadow );
		else{
		    DrawSetLine( dp++, INPX-3, INPY-2, INPX+IMAX*IFONT/2+5,
				    INPY+IFONT+2, ShadowDown, OptionShadow );
		    dp+= InputSetDraw( dp, &Input );
		}
		WindowDraw( wp, dbuf, dp-dbuf );
	}
	return	TRUE;
}

Dialog( cp, com, mes, mode )
ClientPack	*cp;
unsigned char	*com,
		*mes;
int		mode;
{
	WindowID	dwp;
	int		x, y;
	EventInfo	Info;
	EventInfo	*info= &Info;
	short		filec= FALSE;
	short		savex= -1,
			savey;
	short		ret= FALSE;

	if( !cp->askmode && mode == YESNO )
		return	TRUE;

	info->LeftStat= info->RightStat= TRUE;
	commandname= com;
	message= mes;
	dmode= mode;
	dialy= 0;
	if( dmode != YESNO ){
		InputSet( &Input, INPX, INPY, (char*)ibuf, IMAX, FCOLOR, IFONT );
		InputSetCursor( &Input, strlen( ibuf ) );
		dialy= 2;
	}
	WindowGetRootScroll( &x, &y );
	dwp= WindowSimpleOpen( x+WINX, y+WINY, WINH, WINV, NULL, DialogExec );
	Dxwp= dwp;
	WindowRedraw( dwp );
	if( ((cp->automove & AUTOASK) && dmode == YESNO) ||
			((cp->automove & AUTOINPUT) && dmode != YESNO) ){
		savex= ((const unsigned int)MS_CURGT())>>16;
		savey= ((const unsigned int)MS_CURGT())&1023;
		MS_CURST( x+WINX+YESX+4, y+WINY+YESY+4 );
	}

	for(;;){
	    DrawBuf	dbuf[8];
	    if( WindowGetEventInfo( info ) ){
	    	if( dmode != YESNO ){
	    	    WindowID	cwp;
	    	    if( (cwp= WindowGetChild( WindowRootID, info )) != dwp ){
	    	    	WindowSendEvent( cwp, info );
	    	    	continue;
	    	    }
	    	}
	    }
	    if( info->option == EventMouseSwitch ){
		if( info->LeftON ){
		    short	inflag= FALSE;
		    while( WindowGetEventInfo( info ), info->LeftStat ){
			if( WindowGetChild( WindowRootID, info ) != dwp )
			    continue;
			if( IN( YESX-2, YESY-2+dialy, YESX+YESFONT*2+2,
						YESY+YESFONT+2+dialy )){
			    if( !inflag ){
				DrawSetLine( dbuf, YESX-1, YESY-1+dialy,
					YESX+YESFONT*2+0, YESY+YESFONT+1+dialy,
					1|OptionXor, OptionFill );
				WindowDraw( dwp, dbuf, 1 );
			    }
			    inflag= 2;
			}else if( IN( NOX-2, NOY-2+dialy, NOX+NOFONT*2+2,
							NOY+NOFONT+2+dialy )){
			    if( !inflag ){
				DrawSetLine( dbuf, NOX-1, NOY-1+dialy,
					NOX+NOFONT*2+0, NOY+NOFONT+1+dialy,
					1|OptionXor, OptionFill );
				WindowDraw( dwp, dbuf, 1 );
			    }
			    inflag= 1;
			}else{
			    if( inflag ){
				WindowDraw( dwp, dbuf, 1 );
				inflag= FALSE;
			    }
			    if( dmode >= TIME &&
				IN( INPX, INPY-2, INPX+IMAX*IFONT/2,INPY+
						    IFONT+2 ) ){
			 	short	len= strlen( ibuf ),
			 		pos= (info->x-INPX)/(IFONT/2);
			 	if( pos<len ){
				    if( dmode == TIME &&
					    ibuf[pos]>='0' && ibuf[pos]<='9'){
				    	if( info->y-INPY-(IFONT/2)>=0 ){
					    if( ibuf[pos] <= '8' )
						ibuf[pos]++;
					    else
						ibuf[pos]= '0';
					}else{
					    if( ibuf[pos] > '0' )
						ibuf[pos]--;
					    else
						ibuf[pos]= '9';
					}
				    }else if( pos >= cp->attrsafety && pos<=6){
				    	extern unsigned char	AttrStr[];
				    	if( ibuf[pos] >= 'A' )
				    		ibuf[pos]= '-';
					else
						ibuf[pos]= AttrStr[pos];
				    }
				    DrawSetSymbol( dbuf, INPX, INPY, "                                      ", FCOLOR, IFONT );
				    WindowDraw( dwp, dbuf,
					InputSetDraw( dbuf+1, &Input )+1 );
				    leftoffcheck( info );
				}
			    }
			}
		    }
		    if( inflag ){
			ret= inflag-1;
			break;
		    }
		}else if( info->RightON ){
		    if( dmode == YESNO )
			WindowMoveOperation( dwp, info );
		    else{
		    	short	i=PUmenu( cp, 0, dialogmenu, DIALOGMENU );
		    	switch( i ){
		    	case 2: /* clear & paste */
			    WindowDraw( dwp, dbuf, InputKey( dbuf,
						    &Input, 'u'&0x1f, 0 ) );
		    	case 0: /* paste */
			    {
				unsigned char	*p;
		    		p= WindowGetCommon( "Clip Board", 0 );
		    		while( *p ){
				    WindowDraw( dwp, dbuf,
					    InputKey( dbuf, &Input, *p++, 0 ));
				}
				filec= FALSE;
				break;
			    }
			case 1: /* clear */
			    WindowDraw( dwp, dbuf, InputKey( dbuf,
						    &Input, 'u'&0x1f, 0 ) );
			    break;
			    filec= FALSE;
			case 3: {
				unsigned char	*p;
			to_upper:
				for(p= ibuf; *p ; p++ )
					if( *p>='a' && *p<='z')
						*p-= 0x20;
				}
				DrawSetSymbol( dbuf, INPX, INPY, "                                      ", FCOLOR, IFONT );
				WindowDraw( dwp,dbuf,InputSetDraw(dbuf+1,&Input )+1);
				break;
			case 4: {
				unsigned char	*p;
			to_lower:
				for( p= ibuf ; *p ; p++ )
					if( *p>='A' && *p<='Z' )
						*p+= 0x20;
				}
				DrawSetSymbol( dbuf, INPX, INPY, "                                      ", FCOLOR, IFONT );
				WindowDraw( dwp,dbuf,InputSetDraw(dbuf+1,&Input )+1);
				break;
			case 5:	/* move */
			    WindowMoveOperation( dwp, info );
			}
		    }
		}
	    }else if( info->option == EventKey ){
		short	key= keyexec( cp, info, FALSE );
	    	if( dmode == YESNO ){
	    		if( key == 1 ){
				ret= TRUE;
				break;
			}else if( key == 2 ){
				ret= FALSE;
				break;
			}
		}else{
		    if( key == 3 ){
			int	x,y;
			WindowGetScreenPosition( cp->bwp, &x, &y );
			MS_CURST( x+10, y+10 );
		    }else if( info->KeyCode == '\r' ){
		    	ret= TRUE;
		    	break;
		    }else if( info->KeyCode == 0x1b ){
		    	ret= FALSE;
		    	break;
		    }else if( info->KeyCode == 0x8006 ){
		    	goto	to_upper;
		    }else if( info->KeyCode == 0x8007 ){
		    	goto	to_lower;
		    }else if( info->KeyCode == ('i'&0x1f) ){
		    	static struct FILBUF	f;
		    	static unsigned char	filecbuf[PATHMAX],
						dmy[PATHMAX],
						*chp;
		    	if( filec ){
			    if( NFILES( &f )>=0 ){
			    	strcpy( chp, filecbuf );
			    	strcat( chp, f.name );
			    }else
			    	goto	filecgo;
		    	}else{
			    unsigned char	*p= ibuf;
			    for( chp= ibuf ; *p ; *p++ )
			    	if( *p == ' ' )
			    		chp= p;
			    if( *chp == ' ' && chp[1] )
			    	chp++;
			    if( *chp && chp[1] == ':' )
			    	strcpy( filecbuf, chp );
			    else{
				strcpy( filecbuf, cp->path );
				if( *chp == '\\' || *chp == '/' )
				    strcpy( filecbuf+2, chp );
				else
				    strcat( filecbuf, chp );
			    }
			    strcpy( dmy, filecbuf );
			    if( !strchr( dmy, '*' ) )
				    strcat( dmy, strchr(dmy,'.') ?"*":"*.*");
		filecgo:
			    strcpy( filecbuf, dmy );
			    if( FILES( &f, dmy, 0x3f )>=0 ){
			    	filec= TRUE;
			    	*(char*)delpath( filecbuf )= '\0';
			    	strcpy( chp, filecbuf );
			    	strcat( chp, f.name );
			    }
		    	}
			InputSetCursor( &Input, strlen( ibuf ) );
			DrawSetSymbol( dbuf, INPX, INPY, "                                      ", FCOLOR, IFONT );
			WindowDraw( dwp,dbuf,InputSetDraw(dbuf+1,&Input )+1);
		    }else{
			filec= FALSE;
			WindowDraw( dwp, dbuf,
			InputKey( dbuf,&Input,info->KeyCode,info->ShiftStat ));
		    }
		}
	    }
	}
	WindowClose( dwp );
	dmode= 0;
	if( savex >= 0 )
		MS_CURST( savex, savey );
	else if( dialogretflag ){
		int	x,y;
		WindowGetScreenPosition( cp->bwp, &x, &y );
		MS_CURST( x+10, y+10 );
		dialogretflag= FALSE;
	}
	return	ret;
}

#if	TEST
int	WindowHeapSize= 0;
WindowMain()
{
	EventInfo	info;
	MS_CURON();
/*	YesNo( "폜: D:\\LOG\\SPS\\sp910929.log", "sĂ낵łH");*/
	*ibuf= '\0';
	Dialog( "A[JCuWJ","o̓t@C͂ĉ", 1 );
	WindowSendSignal( WindowProcessID, SignalKill, 0 );
}
#endif
