/*	sendname.c Copyright 1991 H.Ogasawara	*/

#include	"mmf.h"

unsigned char *
cutfilename( str )
unsigned char	*str;
{
	static unsigned char	buf[PATHMAX];
	unsigned char		*ptr= buf;
	while( *str != ' ' )
		*ptr++= *str++;
	*ptr= '\0';
	return	buf;
}

markcount( cp )
ClientPack	*cp;
{
	short	i,
		sendnum= 0;

	for( i= 0 ; i< cp->maxline ; i++ ){
		if( cp->line[i]->attr == MCOLOR )
			sendnum++;
	}
	return	sendnum;
}

extmark( cp, ext )
ClientPack	*cp;
unsigned char	*ext;
{
	short	i;
	for( i= 0 ; i< cp->maxline ; i++ ){
		unsigned char	*p= cp->line[i]->str;
		for(; *p && *p != ' ' ; p++ );
		if( *p ){
			unsigned char	*ptr;
			*p= '\0';
			if( ptr= (void*)strchr( cp->line[i]->str, '.' ) ){
				if( !strcmpi( ptr+1, ext ) ){
					if( cp->line[i]->attr != MCOLOR ){
						markdraw( cp, i );
						cp->line[i]->attr= MCOLOR;
					}
				}
			}
			*p= ' ';
		}
	}
}

quickmark( cp, i )
ClientPack	*cp;
int		i;
{
	short	num;
	if( (num= markcount( cp )) == 0 ){
		if( i < 0 )
			return	i;
		markdraw( cp, i );
		cp->line[i]->attr ^= 8;
	}
	return	num;
}

void **
makefilelist( cp )
ClientPack	*cp;
{
	short		i,
			sendnum= markcount( cp )+1;
	unsigned char	(*buf)[PATHMAX];
	void		**ptr,
			*Mem;

	Mem= (void*)WindowMemoryAlloc( sendnum*(PATHMAX+sizeof(void*))+256 );
	if( Mem ){
		buf= (void*)((int)Mem+sizeof(void*)*sendnum);
		ptr= Mem;
		for( i= 0 ; i< cp->maxline ; i++ ){
			if( cp->line[i]->attr == MCOLOR ){
				getfpath( cp, buf, i );
				*ptr++= buf++;
			}
		}
		*ptr= NULL;
		return	Mem;
	}
	conserr( NULL, "mۂł܂" );
	return	NULL;
}

void
sendname( cp, cwp, info )
ClientPack	*cp;
WindowID	cwp;
EventInfo	*info;
{
	void	*ptr= makefilelist( cp );
	if( info->ComBuffer= ptr ){
		info->ComData= UserStrings;
		info->option= EventUser;
		WindowSendEvent( cwp, info );
		WindowMemoryFree( ptr );
	}
}

